<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.0
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');
require_once( JPATH_COMPONENT.DS.'helpers'.DS.'helper.php' );
class SmfaqsController extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'display' );
		$this->registerTask( 'edit'  , 	'display' );
	}

	/**
	 * display the edit form
	 * @return void
	 */
	 
	function display()
	{
		switch($this->getTask())
		{
			case 'add'     :
			{
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'view'  , 'smfaq');
				JRequest::setVar( 'edit', false );

				// Checkout the weblink
				$model = $this->getModel('smfaq');
				$model->checkout();
			} break;
			case 'edit'    :
			{
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'layout', 'form'  );
				JRequest::setVar( 'view'  , 'smfaq');
				JRequest::setVar( 'edit', true );

				// Checkout the weblink
				$model = $this->getModel('smfaq');
				$model->checkout();
			} break;
		}

		parent::display();
	}


	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()	
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		
		$model = $this->getModel('smfaq');
		
		if ($model->store($post)) {
			$msg = JText::_( 'Greeting Saved!' );
			$model->checkin();
			$send_mail = JRequest::getInt( 'send_mail', 0);
			$published = JRequest::getInt( 'published', 0);
			$state     = JRequest::getInt( 'state', 0);
			if ($send_mail && $published && ($state == 2)){
				SmfaqsController::_sendMail();
			}
		} else {
			$msg = JText::_( 'Error Saving Greeting' );
		}
		
		

		$link = 'index.php?option=com_smfaq&view=smfaqs';
				
		$this->setRedirect($link, $msg);
	}
	
	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$model = $this->getModel('smfaq');
		$model->checkin();

		$msg = JText::_( 'Operation Cancelled' );
		
		$this->setRedirect( 'index.php?option=com_smfaq&view=smfaqs', $msg );
	}
	
	function apply()	
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		
		$post	= JRequest::get('post');
		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$post['id'] = (int) $cid[0];
		
		$model = $this->getModel('smfaq');
		
		if ($model->store($post)) {
			$msg = JText::_( 'Greeting Saved!' );
			$send_mail = JRequest::getInt( 'send_mail', 0);
			$published = JRequest::getInt( 'published', 0);
			$state     = JRequest::getInt( 'state', 0);
			if ($send_mail && $published && ($state == 2)){
				SmfaqsController::_sendMail();
			}
			
		} else {
			$msg = JText::_( 'Error Saving Greeting' );
		}
		$msg	= JText::_( 'SUCCESSFULLY SAVED CHANGES' );
		$link	= 'index.php?option=com_smfaq&task=edit&cid[]='. $model->getState('rid');
		$this->setRedirect($link, $msg);
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to delete' ) );
		}

		$model = $this->getModel('smfaq');
		if(!$model->delete($cid)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}
		$msg = JText::_( 'Greeting(s) Deleted' );

		$this->setRedirect( 'index.php?option=com_smfaq&view=smfaqs', $msg );
	}

	
	function publish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to publish' ) );
		}

		$model = $this->getModel('smfaq');
		if(!$model->publish($cid, 1)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_smfaq&view=smfaqs' );
	}
	
	function unpublish()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid = JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);

		if (count( $cid ) < 1) {
			JError::raiseError(500, JText::_( 'Select an item to unpublish' ) );
		}

		$model = $this->getModel('smfaq');
		if(!$model->publish($cid, 0)) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$this->setRedirect( 'index.php?option=com_smfaq&view=smfaqs' );
	}
	
	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel('smfaq');
		$model->move(-1);

		$this->setRedirect( 'index.php?option=com_smfaq');
	}

	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$model = $this->getModel('smfaq');
		$model->move(1);

		$this->setRedirect( 'index.php?option=com_smfaq&view=smfaqs');
	}

	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('smfaq');
		$model->saveorder($cid, $order);

		$msg = JText::_( 'New ordering saved' );
		$this->setRedirect( 'index.php?option=com_smfaq', $msg );
	}
	
	function _sendMail()
	{
		require_once(JPATH_COMPONENT_SITE.DS.'helpers'.DS.'route.php');
		global $mainframe;
		
		$SiteName	= $mainframe->getCfg('sitename');
		$email		= JRequest::getVar( 'email',		'',			'post' );
		$question	= JRequest::getVar( 'question',			'',			'post' );
		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');
		$catid  	= JRequest::getVar( 'catid', 0, '', 'int');

		$subject	= JText::_( 'Answer question') . " (". $SiteName . " )";
		$body = JText::_('On your question');
		$body .= "\n\n" . $question;
		$body .= "\n\r\n" . JText::_('Published answer');
		$body .= "\n\n". JURI::root().SmfaqsHelperRoute::getCategoryRoute($catid);
		$mail = JFactory::getMailer();
		
		$mail->addRecipient( $email );
		$mail->setSender( array( $MailFrom, $FromName ) );
		$mail->setSubject( $subject );
		$mail->setBody( $body );
		
		$sent = $mail->Send();
	}
	
	function reset_vote()
	{
		$id = JRequest::getInt('id');
		$query = ' DELETE FROM #__smfaq_votes ' .
				 ' WHERE question_id = ' . (int) $id;
		$db		=& JFactory::getDBO();
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseError( 500, $db->stderr());
		}
		echo JText::_('Vote reset');
	}
	
	function reset_send_mail()
	{
		$id = JRequest::getInt('id');
		$query = ' UPDATE #__smfaq ' .
				 ' SET send_mail = 0' .
				 ' WHERE id = ' . (int) $id;
		$db		=& JFactory::getDBO();
		$db->setQuery($query);
		if (!$db->query()) {
			JError::raiseError( 500, $db->stderr());
		}
		echo JText::_('Send mail reset');
	}
	
	
}