<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.0
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
 
// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class SmfaqsModelSmfaqs extends JModel
{
	/**
	 * @var array
	 */
	var $_data;
	/**
	 * Items total
	 * @var integer
	 */
	var $_total = null;
   /**
	 * Pagination object
	 * @var object
	 */
	var $_pagination = null;

	function __construct()
	{
		parent::__construct();
 
        global $mainframe, $option;
 
        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
 
        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
 
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
	}
	 
	function _buildQuery()
	{
		$orderby = $this->_buildContentOrderBy();
		$where = $this->_buildContentWhere();
		$query = ' SELECT a.*, cc.title AS category, v.vote_yes AS vote_yes, v.vote_no AS vote_no, u.name AS editor '
			. ' FROM #__smfaq AS a'
			. ' LEFT JOIN #__categories AS cc ON cc.id = a.catid '
			. ' LEFT JOIN #__smfaq_votes AS v ON a.id = v.question_id '
			. ' LEFT JOIN #__users AS u ON u.id = a.checked_out '
			. $where
			. $orderby;
		

		return $query;
	}

	/**
	 * @return array Array of objects containing the data from the database
	 */
	function getData()
	{
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))
		{
			$query = $this->_buildQuery();
			 $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit')); 
		}

		return $this->_data;
	}
	
	function getTotal()
  	{
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);    
        }
        return $this->_total;
  	}
	
	function getPagination()
	{
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
  	}
	
	function _buildContentOrderBy()
	{
        global $mainframe, $option;
 
        $filter_order     = $mainframe->getUserStateFromRequest( $option.'filter_order', 'filter_order', 'a.question', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
 
        $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
 
        return $orderby;
	}
	
	function _buildContentWhere()
	{
		global $mainframe, $option;
		$db					=& JFactory::getDBO();
		$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '', 'word' );
		$filter_state_ans = $mainframe->getUserStateFromRequest( $option.'filter_state_ans', 'filter_state_ans', '', 'word' );
  		$filter_catid = $mainframe->getUserStateFromRequest( $option.'filter_catid', 'filter_catid', 0, 'int' );
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		if ($search) {
			$where[] = 'LOWER(a.question) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		
		if ($filter_catid > 0) {
		  $where[] = 'a.catid = '.(int) $filter_catid;
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
			$where[] = 'a.published = 1';
			} else if ($filter_state == 'U' ) {
			$where[] = 'a.published = 0';
			}
		}
		if ( $filter_state_ans ) {
			if ( $filter_state_ans == 'W' ) {
			$where[] = 'a.state = 0';
			} else if ($filter_state_ans == 'N' ) {
			$where[] = 'a.state = 1';
			} else if ($filter_state_ans == 'Y' ) {
			$where[] = 'a.state = 2';
			}
		}
		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}
	
}