<?php
/**
 * SM FAQ - simple faq component for Joomla! 1.5
 * @version 1.1
 * @package SM FAQ
 * @author SmokerMan
 * @author url http://joomla.forsite.org
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

class SmfaqsViewCategory extends JView
{
	function display( $tpl = null )
	{
		global $mainframe;
		
		JHTML::_( 'behavior.mootools' ); 
		// Initialize some variables
		$document	= &JFactory::getDocument();
		$uri 		= &JFactory::getURI();
		$pathway	= &$mainframe->getPathway();
		$user = &JFactory::getUser();

		// Get some data from the model
		$items = &$this->get('data' );
		$total = &$this->get('total');
		$pagination = &$this->get('pagination');
		$category = &$this->get('category' );
		$state = &$this->get('state');
		
		// Get the page/component configuration

		$category->total = $total;
		$params = &$mainframe->getParams();
		
		
		if ($params->get('smfaqcheck')) {
			if (!$params->get( 'page_title')) {
				$params->set('page_title', $category->title);
			}
		} else {
			$params = &JComponentHelper::getParams( 'com_smfaq' );
			$params->set('page_title',	$category->title);
			$params->def('display_num',				10);
			$params->def('show_pagination_limit',	0);
			$params->def('show_desc',				0);
			$params->def('add_question',			2);
		}
		$document->setTitle( $params->get( 'page_title' ) );
		
		$script = 
		"window.addEvent('domready', function(){
			var accordion = new Accordion($$('.question'), $$('.answer'), {
				opacity: " . $params->get( 'show_transp', 1 ) . ",
				show : " . $params->get( 'show_first_ans', -1 ) . ",
				onActive: function(toggler, element){
				toggler.setStyle('color', '" . $params->get( 'act_color', '#135CAE' ) . "');
				},
				onBackground: function(toggler, element){
				toggler.setStyle('color', '" . $params->get( 'back_color', '#000000' ) . "');
				}


				
			}, $('questions'));
		});";
		$document->addScriptDeclaration($script);
		
		if ($params->get('show_vote')) {
			$script_vote = "
				function RadioCheck(f, value) {
				var id = f.questionid.value;
				var url = 'index.php?option=com_smfaq&task=storevote&format=raw&id='+id+'&vote='+value;
				f.empty().addClass('ajax-loading'); 
				new Ajax(url, {
					update: f,
					method: 'post',
					onComplete: function() {
						f.removeClass('ajax-loading');
							 var fx = f.effects({transition: Fx.Transitions.Quint.easeOut});
							 fx.start({
							 }).chain(function() {
							 this.start.delay(3000, this, {'opacity' : 0});
							 }).chain(function() {
							 this.start.delay(0100, this, {'opacity' : 1});
							 f.remove();
							 });
					}
				}).request();
				}";
			$document->addScriptDeclaration($script_vote);
		}
		
		$baseurl = JURI::base();
		$document->addStyleSheet($baseurl . "components/com_smfaq/css/smfaq.css");

		if (isset( $category->image ) && $category->image != '')
		{
			$attribs['align']  = $category->image_position;
			$attribs['hspace'] = 6;

			// Use the static HTML library to build the image tag
			$category->image = JHTML::_('image', 'images/stories/'.$category->image, JText::_('SM Faq'), $attribs);
		}
		
		if ($params->get('add_question') <= $user->get('aid', 0)) {
			
			$menus	= &JSite::getMenu();
			$menu	= $menus->getActive();
			$document->addScript($baseurl . "components/com_smfaq/js/smfaq.js");

			$params->link_add = '<a id="addquestion" class="button" href="#"><span>'. JText::_('Add question') . '</span></a><div id="time"></div>';
			if ($user->get('gid') > 19) {
				$script = "window.addEvent('domready', function() {
					var url = 'index.php?option=com_smfaq&controller=admin&task=shownoanswer&format=raw&catid='+".$category->id."+'&Itemid='+".$menu->id.";
					$('noanswer').addEvent('click', function(e) {
					new Event(e).stop();
					$('questionnoanswer').empty().addClass('ajax-loading');
					var ajax2 = new Ajax(url, {
							update: $('questionnoanswer'),
							method: 'post',
							onComplete: function() {
								$('questionnoanswer').removeClass('ajax-loading');
								var noitems = $('noitems');
								if (noitems) {
									  var fx = noitems.effects({transition: Fx.Transitions.Quint.easeOut});
									  fx.start({
									  }).chain(function() {
									  this.start.delay(2000, this, {'opacity' : 0});
									  }).chain(function() {
									  this.start.delay(0100, this, {'opacity' : 1});
									  noitems.remove();
									 });
								}
							   }
							  }).request();
					});
					});";
				$document->addScriptDeclaration($script);
				$params->link_add = '<div><a href="index.php?option=com_smfaq&controller=admin&task=edit&catid='. $category->id .'&ret='.base64_encode($uri->toString()).'" class="button"><span>'. JText::_('Add question') . '</span></a>';
				$params->link_add .= '<a href="#" class="button" id="noanswer"><span>'.JText::_('Show no published').'</span></a></div><div id="questionnoanswer"></div>';
			}
			$params->link_add .= '<input type="hidden" id="smcatid" value="'. $category->id. '" /><input type="hidden" id="Itemid" value="'. $menu->id. '" /><input type="hidden" id="count" value="'.$params->get('count', 1000).'" />';
		} else {
			if (($params->get('add_question') == '2') && ($user->get('gid') < 19)) {
				$params->link_add = null;
			} else {
				$params->link_add = Jtext::_('Registered to add question');
			}
		}
		
		$this->assignRef('user',		$user);
		$this->assignRef('params',		$params);
		$this->assignRef('category',	$category);
		$this->assignRef('items',		$items);
		$this->assignRef('pagination',	$pagination);
		$this->assign('ret',	$uri->toString());

		parent::display($tpl);
	}
}
